<template>
  <v-dialog
    :value="value"
    max-width="290"
    @keydown.esc="closeRequest"
    @click:outside="closeRequest"
    content-class="round"
  >
    <div class="flex flex-col bg-white p-7 justify-between gap-8">
      <div class="flex-grox flex-row">
        <div class="text-xl font-semibold text-center">
          {{ title }}
        </div>
      </div>
      <div class="flex flex-col">
        <div>
          <div class="my-5 text-sm">
            <v-form
              lazy-validation
              ref="form"
              v-model="valid"
              @submit.prevent="onModalSubmit()"
            >
              <v-text-field
                label="Nom"
                id="nom"
                :rules="nomRules"
                required
                v-model="savoir.nom"
              ></v-text-field>
              <v-select
                required
                :items="bulletins"
                item-text="nom"
                item-value="bulletin"
                :rules="bulletinRules"
                return-object
                v-model="savoir.bulletin"
                label="Bulletin"
                no-data-text="Pas de bulletin créé"
              ></v-select>
            </v-form>
          </div>
        </div>
      </div>
      <div class="flex flex-row-reverse justify-between">
        <div>
          <button
            @click="onModalSubmit()"
            class="font-medium bg-bleu text-gray-50 text-sm py-2.5 px-5 rounded-lg hover:bg-bleuHover focus:outline-none"
          >
            {{ updating ? "Modifier" : "Ajouter" }}
          </button>
        </div>
        <div
          id="deleteMatCompSav"
          @click="onModalSubmit({ deleting: true })"
          class="cursor-pointer font-medium border border-red-400 text-red-400 text-sm py-2.5 px-5 rounded-lg hover:bg-red-400 hover:text-gray-50 focus:outline-none"
          v-show="updating"
        >
          Effacer
        </div>
      </div>
    </div>
  </v-dialog>
</template>

<script>
export default {
  emits: ["closeRequest, onModalSubmit"],
  props: {
    updatedSavoir: Object,
    forCompetence: { type: Object, required: false },
    value: Boolean,
  },
/*   created() {
    this.$store.dispatch("bindBulletins", this.classe);
  }, */

  methods: {
    closeRequest() {
      this.$emit("closeRequest");
    },

    onModalSubmit(deleting = false) {
      if (this.$refs.form.validate()) {
        if (deleting == false) {
          this.$store.dispatch("addSavoir", {
            ...this.savoir,
            competence: this.forCompetence,
          });
        } else this.$store.dispatch("savoirs/delete", this.savoir.id);
        this.closeRequest();
      }
    },
  },

  data() {
    return {
      valid: false,
      updating: Object.keys(this.updatedSavoir).length != 0,
      savoir: { ...this.updatedSavoir } || {},
      nomRules: [(v) => !!v || "Le nom est requis"],
      bulletinRules: [(v) => !!v || "Le bulletin est requis"],
    };
  },

  computed: {
    title() {
      return this.updating
        ? `Modifier le savoir ${this.updatedSavoir.nom}`
        : `Ajouter un savoir à ${this.forCompetence.nom}`;
    },
    bulletins() {
      return this.$store.state.bulletins;
    },
    classe() {
      return this.$store.getters.getOneClasse(this.$route.params.classeid);
    },
  },
};
</script>
